package cn.fastfun.service.entity;


import com.bridge.entity.IdEntity;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
import org.hibernate.annotations.JoinColumnOrFormula;
import org.hibernate.annotations.JoinColumnsOrFormulas;
import org.hibernate.annotations.JoinFormula;

import javax.persistence.*;


@Entity
@Table(name = "sys_role")
@Setter
@Getter
public class SysRole extends IdEntity {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "标题", name = "title", required = true)
    @Column(name = "title")
    private String title;


    @ApiModelProperty(value = "编码", name = "code", required = true)
    @Column(name = "code")
    private String code;


    @ApiModelProperty(value = "机构", name = "orgId", required = true)
    @Column(name = "org_id")
    private String orgId;


    @ApiModelProperty(value = "状态0待审,1正常 9停用", name = "status", required = true)
    @Column(name = "status")
    private Integer status;


    // 关联
    @JsonIgnore
    @ManyToOne(targetEntity = SysDict.class)
    @JoinColumnsOrFormulas(value = {
            @JoinColumnOrFormula(column = @JoinColumn(name = "status", referencedColumnName = "name", insertable = false, updatable = false, nullable = false)),
            @JoinColumnOrFormula(formula = @JoinFormula(value = "'sys_role_status'", referencedColumnName = "group_name"))
    })
    private SysDict statusDict;

    @Transient
    @JsonInclude(value = JsonInclude.Include.NON_NULL)
    public String getStatusTitle() {
        return null != statusDict ? statusDict.getValue() : "";
    }
}
